package ru.amse.vorobiev.lce.elements.impl;

import ru.amse.vorobiev.lce.elements.IPlug;
import ru.amse.vorobiev.lce.elements.IWire;

public class Wire implements IWire {
    private IPlug myStart;
    private IPlug myEnd;
    
    public Wire(IPlug start, IPlug end) {
    	this.setFrom(start);
    	this.setTo(end);
    }
    
    public Wire() {
    	this(null, null);
    }
    
    public void setTo(IPlug plug) {
    	if (plug != myEnd) {
    		if (myEnd != null) {
    			myEnd.setWire(null);
    		}
    		if (plug != null) {
    			if (plug.getType() != PlugType.INPUT) {
    				throw new UnsupportedOperationException();
    			}
    			myEnd = plug;
    			plug.setWire(this);
    		} else {
    			myEnd = null;
    		}
    	}
    }
    
    public void setFrom(IPlug plug) {
    	if (plug != myStart) {
    		if (myStart != null) {
    			myStart.setWire(null);
    		}
    		if (plug != null) {
    			if (plug.getType() != PlugType.OUTPUT) {
    				throw new UnsupportedOperationException();
    			}
    			myStart = plug;
    			plug.setWire(this);
    		} else {
    			myStart = null;
    		}
    	}
    }
    
    public IPlug getTo() {
    	return myEnd;
    }
    
    public IPlug getFrom() {
    	return myStart;
    }
}
