package ru.amse.vorobiev.lce.ui;

import java.util.List;

import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import ru.amse.vorobiev.lce.validator.IError;
import ru.amse.vorobiev.lce.view.IElementView;

public class ErrorSelectionListener implements ListSelectionListener{
	private final ErrorTableModel myTableModel;
	private final JEditor myEditor;
	private IElementView myLastSelection;
	
	public ErrorSelectionListener(ErrorTableModel tableModel, JEditor editor) {
		myTableModel = tableModel;
		myEditor = editor;
		myLastSelection = null;
	}

	public void valueChanged(ListSelectionEvent e) {
		ListSelectionModel selectionModel = (ListSelectionModel) e.getSource();
		int row = selectionModel.getMaxSelectionIndex();
		if (row != -1) {
			List<IError> errors = myTableModel.getErrors();
			if (myLastSelection != null && selectionModel.isSelectionEmpty()) {
				myLastSelection.setSelectedAsError(false);
				myLastSelection = null;
			} else {
				IElementView element = myEditor.getView().getViewByElement(errors.get(row).getElement());
				if (myLastSelection != null) {
					myLastSelection.setSelectedAsError(false);
				}
				myLastSelection = element;
				element.setSelectedAsError(true);
				myEditor.repaint();
			}
		}
	}

}
