package ru.amse.vorobiev.lce.ui;

import java.util.ArrayList;
import java.util.List;

import javax.swing.event.TableModelEvent;
import javax.swing.table.AbstractTableModel;

import ru.amse.vorobiev.lce.validator.IError;

public class ErrorTableModel extends AbstractTableModel{
	private static final long serialVersionUID = 1L;
	private List<IError> myErrors;
	
	public ErrorTableModel(List<IError> errors) {
		myErrors = errors;
	}
	
	public ErrorTableModel() {
		myErrors = new ArrayList<IError>();
	}
	
	public void setErrors(List<IError> errors) {
		myErrors = errors;
		this.fireTableChanged(new TableModelEvent(this));
	}

	public int getColumnCount() {
		return 1;
	}

	public int getRowCount() {
		return myErrors.size();
	}

	public Object getValueAt(int arg0, int arg1) {
		return myErrors.get(arg0).getMessage();
	}
	
	public boolean isCellEditable(int row, int col) { 
		return false; 
	}
	
	public String getColumnName(int index) {
		return "Errors";
	}
	
	public List<IError> getErrors() {
		return myErrors;
	}

}
