package ru.amse.vorobiev.lce.ui.tools.impl;

import java.awt.Graphics;
import java.awt.event.MouseEvent;

import javax.swing.JOptionPane;

import ru.amse.vorobiev.lce.elements.impl.GateType;
import ru.amse.vorobiev.lce.ui.JEditor;
import ru.amse.vorobiev.lce.ui.tools.ITool;
import ru.amse.vorobiev.lce.view.IGateView;

public class SettingInputsTool implements ITool{
	private JEditor myEditor;

	public void paint(Graphics g) {
		// TODO Auto-generated method stub
		
	}
	
	public SettingInputsTool(JEditor editor) {
		myEditor = editor;
	}
	
	public void mouseClicked(MouseEvent e) {
		if (myEditor.getView() != null) {
			int x = e.getX();
			int y = e.getY();
			if (e.getClickCount() == 2) {
				IGateView gateView = myEditor.getView().getGateForLocation(x, y);
				if (gateView != null && gateView.getGate().getType() == GateType.IN) {
					String message = "Enter input signals (" + gateView.getGate().getOutputCount() + " characters, '0' and '1' only)";
					String inputs = JOptionPane.showInputDialog(message);
					while (inputs != null && !myEditor.setInputs(inputs, gateView)) {
						inputs = JOptionPane.showInputDialog("The string you've entered is incorrect.\n" + message);
					}
					
				}	
			}
		}
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseDragged(MouseEvent e) {
	}

	public void mouseMoved(MouseEvent e) {
	}

}
