package ru.amse.vorobiev.lce.view.impl;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;

import ru.amse.vorobiev.lce.elements.IWire;
import ru.amse.vorobiev.lce.view.ICircuitView;
import ru.amse.vorobiev.lce.view.IPlugView;
import ru.amse.vorobiev.lce.view.IWireView;

public class WireView implements IWireView{
	private final IWire myWire;
	private ICircuitView myCircuitView;
	private Point myPoint;
	private boolean isSelectedAsError;
	
	public WireView(IWire wire, ICircuitView circuitView) {
		myPoint = new Point();
		myWire = wire;
		myCircuitView = circuitView;
		myCircuitView.addViewByElement(wire, this);
	}
	
	public IWire getWire() {
		return myWire;
	}
	
	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		Point start = new Point();
		Point end = new Point();
		start = ((IPlugView) myCircuitView.getViewByElement(myWire.getFrom())).getCenter();
		end = ((IPlugView) myCircuitView.getViewByElement(myWire.getTo())).getCenter();
		if (isSelectedAsError) {
			g2.setColor(Color.RED);
		} 
		g2.drawLine(start.x, start.y, end.x, end.y);
	}
	
	public void setPoint(int x, int y) {
		myPoint.x = x;
		myPoint.y = y;
	}
	
	public Point getPoint() {
		return myPoint;
	}

	public void setSelectedAsError(boolean condition) {
		isSelectedAsError = condition;
	}
}
