package ru.amse.vorobiev.lce.elements;

import ru.amse.vorobiev.lce.elements.impl.AndGate;
import ru.amse.vorobiev.lce.elements.impl.OrGate;
import ru.amse.vorobiev.lce.elements.impl.Plug;
import ru.amse.vorobiev.lce.elements.impl.PlugType;
import junit.framework.TestCase;

public class PlugTest extends TestCase {
	private Plug myPlug;	
	
	public void testSetGetSignal() {
		myPlug = new Plug(new AndGate(), PlugType.INPUT);
		myPlug.setSignal(false);
		assertEquals(false, myPlug.getSignal());
	}

	public void testHasNoSignal() {
		myPlug = new Plug (new AndGate(), PlugType.INPUT);
		assertFalse(myPlug.hasSignal());
	}
	
	public void testHasSignal() {
		myPlug = new Plug (new AndGate(), PlugType.INPUT);
		myPlug.setSignal(true);
		assertTrue(myPlug.hasSignal());
	}

	public void testGetGate() {
		OrGate gate = new OrGate();
		IPlug plug = gate.getInput(0);
		assertEquals(gate, plug.getGate());
	}

	public void testGetType() {
		myPlug = new Plug(new OrGate(), PlugType.OUTPUT);
		assertEquals(PlugType.OUTPUT, myPlug.getType());
	}

}
