package ru.amse.vorobiev.lce.elements;

import ru.amse.vorobiev.lce.elements.impl.AndGate;
import ru.amse.vorobiev.lce.elements.impl.Plug;
import ru.amse.vorobiev.lce.elements.impl.PlugType;
import ru.amse.vorobiev.lce.elements.impl.Wire;
import junit.framework.TestCase;

public class WireTest extends TestCase {
	private Wire myWire;
	
	public void testSetTo() {
		myWire = new Wire();
		Plug a = new Plug(new AndGate(), PlugType.INPUT);
		myWire.setTo(a);
		assertEquals(myWire, a.getWire());
	}

	public void testSetToOutput() {
		myWire = new Wire();
		Plug b = new Plug(new AndGate(), PlugType.OUTPUT);
		try {
			myWire.setTo(b);
			fail();
		} catch (UnsupportedOperationException e) {	
		}
	}

	public void testSetFrom() {
		myWire = new Wire();
		Plug a = new Plug(new AndGate(), PlugType.OUTPUT);
		myWire.setFrom(a);
		assertEquals(myWire, a.getWire());
	}

	public void testSetFromInput() {
		myWire = new Wire();
		Plug b = new Plug(new AndGate(), PlugType.INPUT);
		try {
			myWire.setFrom(b);
			fail();
		} catch (UnsupportedOperationException e) {	
		}
	}

	public void testGetTo() {
		myWire = new Wire();
		Plug a = new Plug(new AndGate(), PlugType.INPUT);
		myWire.setTo(a);
		assertEquals(a, myWire.getTo());
	}

	public void testGetFrom() {
		myWire = new Wire();
		Plug a = new Plug(new AndGate(), PlugType.OUTPUT);
		myWire.setFrom(a);
		assertEquals(a, myWire.getFrom());
	}

}
